%define with_gcj %{!?_without_gcj:1}%{?_without_gcj:0}
%define multilib_arches ppc64 sparc64 x86_64

Name:           simplyhtml
Version:        0.12.5
Release:        9%{?dist}
Epoch:          0
Summary:        Application and a java component for rich text processing
# All files are GPL except for src/com/sun/demo/ElementTreePanel.java which has
# a BSD license.
License:        GPLv2+ and BSD
Group:          Development/Java
URL:            http://simplyhtml.sourceforge.net/
Source0:        http://downloads.sourceforge.net/simplyhtml/SimplyHTML_src_%(echo %{version} | sed -e 's/\./_/g').tar.gz
# cvs -z3 -d:pserver:guest@simplyhtml.cvs.sourceforge.net:/cvsroot/simplyhtml export -r shtml_0_12_5 shtml/gpl.txt
# mv shtml/gpl.txt .
Source1:        gpl.txt
# cvs -z3 -d:pserver:guest@simplyhtml.cvs.sourceforge.net:/cvsroot/simplyhtml export -r shtml_0_12_5 shtml/readme.txt
# mv shtml/readme.txt .
Source2:        readme.txt
Source3:        simplyhtml.sh
Patch0:         simplyhtml-build_xml.patch
Patch1:         simplyhtml-ExampleFileFilter.patch
Requires:       gnu-regexp
Requires:       javahelp2
Requires:       java
Requires:       jpackage-utils
BuildRequires:  ant
BuildRequires:  gnu-regexp
BuildRequires:  javahelp2
BuildRequires:  java-devel >= 1:1.6.0
BuildRequires:  jpackage-utils
%if %{with_gcj}
BuildRequires:  java-gcj-compat-devel >= 1.0.31
Requires(post): java-gcj-compat >= 1.0.31
Requires(postun): java-gcj-compat >= 1.0.31
%else
BuildArch:      noarch
%endif
# We need this to get a version of ElementTreePanel with an acceptable license
BuildRequires:  java-1.6.0-openjdk-demo
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
SimplyHTML is an application and a java component for rich text
processing. It stores documents as HTML files in combination with
Cascading Style Sheets (CSS). SimplyHTML is not intended to be used
as an editor for web pages.

%package javadoc
Summary:        Javadoc documentation for %{name}
Group:          Development/Documentation
Requires:       %{name} = %{version}-%{release}
Requires:       jpackage-utils

%description javadoc
Javadoc documentation for %{name}.

%prep
%setup -q -c %{name}-%{version}
# In the 0.12.5 version of the source tarball, we simply get the com and de
# directories spewed out into the current directory, without so much as even
# an all encompassing name-version directory.  Hence, we need the -c flag for
# the setup macro above.  But it gets even better.  It turns out that the
# build.xml file still references directories like ../bin and ../lib even
# though those directories are now outside of the source tree.  So now we have
# to manually create a src directory and move everything from the source tarball
# into that directory first.
mkdir lib src
mv build.xml com de MANIFEST.MF src

# We need to remove the carriage returns *before* applying patch 0
%{__perl} -pi -e 's/\r$//' src/build.xml
%patch0 -p0 -b .build_xml
%{_bindir}/find . -name '*.jar' | %{_bindir}/xargs -t %{__rm}
%{__cp} %{SOURCE1} %{SOURCE2} .

%patch1 -p1 -b .ExampleFileFilter
rm src/com/sun/demo/ExampleFileFilter.java

# Now bring in a version of ElementTreePanel that doesn't have a "No nukes"
# clause in its license
pushd src/com/sun/demo
mv ElementTreePanel.java ElementTreePanel.java.BadLicense
%ifarch %{multilib_arches}
  unzip %{_prefix}/lib/jvm/java-1.6.0-openjdk-1.6.0.0.%{_arch}/demo/jfc/Notepad/src.zip \
    ElementTreePanel.java
%else
  unzip %{_prefix}/lib/jvm/java-1.6.0-openjdk-1.6.0.0/demo/jfc/Notepad/src.zip \
    ElementTreePanel.java
%endif
sed -i -e '33 i\
/* for use in SimplyHTML */\
package com.sun.demo;' ElementTreePanel.java
popd

%{_bindir}/find . -type f -name '*.htm' | \
  %{_bindir}/xargs -t %{__perl} -pi -e 's/\r$//g'

%{__perl} -pi -e 's/^Class-Path:.*\n//;' \
              -e 's/^Created-By:.*\n//;' \
              src/MANIFEST.MF

#We don't need these with Patch 0
#cd lib
#%{__ln_s} $(build-classpath gnu-regexp) gnu-regexp-1.1.4.jar
#%{__ln_s} $(build-classpath javahelp2) jhall.jar
#cd ..

%build
export CLASSPATH=
export OPT_JAR_LIST=:
cd src
ant
ant javadoc
cd ..

%install
%{__rm} -rf %{buildroot}

%{__mkdir_p} %{buildroot}%{_javadir}
%{__mkdir_p} %{buildroot}%{_bindir}

%{__cp} -a dist/lib/SimplyHTML.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
%{__ln_s} %{name}-%{version}.jar %{buildroot}%{_javadir}/%{name}.jar
%{__ln_s} %{name}-%{version}.jar %{buildroot}%{_javadir}/SimplyHTML-%{version}.jar
%{__ln_s} SimplyHTML-%{version}.jar %{buildroot}%{_javadir}/SimplyHTML.jar

%{__cp} -a dist/lib/SimplyHTMLHelp.jar %{buildroot}%{_javadir}/%{name}-help-%{version}.jar
%{__ln_s} %{name}-help-%{version}.jar %{buildroot}%{_javadir}/%{name}-help.jar
%{__ln_s} %{name}-help-%{version}.jar %{buildroot}%{_javadir}/SimplyHTMLHelp-%{version}.jar
%{__ln_s} SimplyHTMLHelp-%{version}.jar %{buildroot}%{_javadir}/SimplyHTMLHelp.jar

%{__cp} %{SOURCE3} %{buildroot}%{_bindir}
%{__ln_s} %(basename %{SOURCE3}) %{buildroot}%{_bindir}/%(basename %{SOURCE3} .sh)

%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -a dist/api/* %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %{with_gcj}
%{_bindir}/aot-compile-rpm
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%if %{with_gcj}
if [ -x %{_bindir}/rebuild-gcj-db ] ; then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%if %{with_gcj}
if [ -x %{_bindir}/rebuild-gcj-db ] ; then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
#%doc doc/*
%doc gpl.txt readme.txt
%{_bindir}/simplyhtml
%attr(0755,root,root) %{_bindir}/simplyhtml.sh
%{_javadir}/*.jar
%if %{with_gcj}
%attr(-,root,root) %{_libdir}/gcj/%{name}
%endif

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}


%changelog
* Wed Mar  5 2009 John Guthrie <guthrie@counterexample.org> 0:0.12.5-9
- Adding a version specification to the java-devel BuildRequirement so that
  java-1.6.0-openjdk-devel-1.6.0.0 will get included in the build environment.

* Wed Mar  4 2009 John Guthrie <guthrie@counterexample.org> 0:0.12.5-8
- Typo fix in spec file.

* Wed Mar  4 2009 John Guthrie <guthrie@counterexample.org> 0:0.12.5-7
- More 64-bit file location fixes.

* Wed Mar  4 2009 John Guthrie <guthrie@counterexample.org> 0:0.12.5-6
- It turns out that the files for the java-1.6.0-openjdk-demo are placed in
  %%{_prefix}/lib, not %%{_libdir}.  (This is significant for 64-bit
  architectures.) The appropriate line to unzip the ElementTreePanel.java file
  out of the needed zip file was fixed.

* Wed Feb 25 2009 John Guthrie <guthrie@counterexample.org> 0:0.12.5-5
- Fixed the perms on the simplyhtml.sh source file.  Allowing the %%attr to
  take care of the perms.

* Thu Feb 12 2009 John Guthrie <guthrie@counterexample.org> 0:0.12.5-4
- Replaced the version of ElementTreePanel.java that came with the source code
  with a version that has an acceptable license.  Added java-1.6.0-openjdk-demo
  as a BuildRequire as a result.
- Updated the license tag.

* Mon Feb  9 2009 John Guthrie <guthrie@counterexample.org> 0:0.12.5-3
- So it turns out that the source tarball doesn't come with the javadoc
  documentation because the javadoc documentation can be generated using the
  build.xml file.  Therefore, I added a command to do this as well as
  uncommenting all of the javadoc-related portions of the Spec file.
- Removed dependecy on ExampleFileFilter.

* Sat Feb  7 2009 John Guthrie <guthrie@counterexample.org> 0:0.12.5-2
- Added simplyhtml.sh script to run the .jar file with the correct CLASSPATH.

* Fri Feb  6 2009 John Guthrie <guthrie@counterexample.org> 0:0.12.5-1
- Upgraded to 0.12.5.  This included making changes for new source code tree
  structure.
- Added -c flag to %%setup.
- Changed %%patch in %%prep to %%patch0.
- Replaced tabs with spaces to make rpmlint happy.

* Mon Sep 15 2008 John Guthrie <guthrie@counterexample.org> 0:0.12.3-2
- Added several Requires and BuildRequires lines as required by
  Packaging/Java guidelines.
- Changed source to version that is downloadable from the simplyhtml web page
  as opposed to just a tag from the simplyhtml CVS.
- Added gpl.txt and readme.txt to documentation.
- Stripped carriage returns from build.xml.
- Changed the package group for the javadoc subpackage.

* Tue Sep  2 2008 John Guthrie <guthrie@counterexample.org> 0:0.12.3-1
- Re-built RPM for Fedora 9
- Removed symlinks to .jar files from lib

* Sun Aug 10 2008 David Walluck <walluck@mandriva.org> 0:0.12.3-0.0.1mdv2009.0
+ Revision: 270182
- 0.12.3

* Sat Dec 29 2007 David Walluck <walluck@mandriva.org> 0:0.12.2-0.0.3mdv2008.1
+ Revision: 139131
- fix jar symlinks

* Sat Dec 29 2007 David Walluck <walluck@mandriva.org> 0:0.12.2-0.0.2mdv2008.1
+ Revision: 139120
- add Requires
- import simplyhtml
